'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withStyles;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _csjs = require('csjs');

var _csjs2 = _interopRequireDefault(_csjs);

var _insertStyle = require('./insert-style');

var _insertStyle2 = _interopRequireDefault(_insertStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cache = new Map();

function withStyles(css) {
  return function (DecoratedComponent) {
    var _class, _temp;

    return _temp = _class = function (_Component) {
      _inherits(WithStyleDecorator, _Component);

      function WithStyleDecorator() {
        _classCallCheck(this, WithStyleDecorator);

        return _possibleConstructorReturn(this, (WithStyleDecorator.__proto__ || Object.getPrototypeOf(WithStyleDecorator)).apply(this, arguments));
      }

      _createClass(WithStyleDecorator, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          var refs = cache.get(DecoratedComponent);
          if (!refs) {
            this.elm = (0, _insertStyle2.default)(_csjs2.default.getCss(css));
            cache.set(DecoratedComponent, { style: this.elm, count: 1 });
          } else {
            this.elm = refs.style;
            refs.count++;
          }
        }
      }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate() {
          if (process.env.NODE_ENV !== 'production') {
            // Support React Hot Loader
            var cssText = _csjs2.default.getCss(css);
            if ((0, _insertStyle.getStyle)(this.elm) !== cssText) {
              this.elm = (0, _insertStyle2.default)(cssText, { element: this.elm });
            }
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          var refs = cache.get(DecoratedComponent);
          if (--refs.count === 0) {
            cache.delete(DecoratedComponent);
            (0, _insertStyle.removeStyle)(this.elm);
            this.elm = null;
          }
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(DecoratedComponent, _extends({ classes: css }, this.props));
        }
      }]);

      return WithStyleDecorator;
    }(_react.Component), _class.displayName = 'csjs(' + (DecoratedComponent.displayName || DecoratedComponent.name || 'Component') + ')', _temp;
  };
}