'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getStyle = getStyle;
exports.removeStyle = removeStyle;

exports.default = function (css) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var elm = options.element || document.createElement('style');
  elm.setAttribute('type', 'text/css');

  if ('textContent' in elm) {
    elm.textContent = css;
  } else {
    elm.styleSheet.cssText = css; // IE8
  }

  if (!options.element) {
    var head = document.getElementsByTagName('head')[0];
    if (options && options.prepend) {
      head.insertBefore(elm, head.childNodes[0]);
    } else {
      head.appendChild(elm);
    }
  }

  return elm;
};

function getStyle(elm) {
  if ('textContent' in elm) {
    return elm.textContent;
  }

  return elm.styleSheet.cssText; // IE8
}

function removeStyle(elm) {
  return elm.parentNode.removeChild(elm);
}